<?php

class openapi_data_original_stock{

    /**
     * @param Array $filter 过滤条件
     * @param Int $offset 下标
     * @param Int $limit 限制条数
     * 
     * @return void
     * @author 
     **/
    public function getBnBranchStore($filter,$offset,$limit = 100)
    {
        $basicMStockFreezeLib  = kernel::single('material_basic_material_stock_freeze');
        $where = array(1);

        /*
        if ($filter['brand_name']) {
            $brandModel = app::get('ome')->model('brand');
            $brand = $brandModel->dump(array('brand_name' => $filter['brand_name']),'brand_id');
            $where[] = 'g.brand_id=' . $brand['brand_id'];
        }

        if ($filter['type_name']) {
            $goodsTypeModel = app::get('ome')->model('goods_type');
            $goods_type = $goodsTypeModel->dump(array('name' => $filter['type_name']),'type_id');
            $where[] = 'g.type_id=' . $goods_type['type_id'];
        }
        */

        if ($filter['goods_bn']) {
            $salesMaterialObj = app::get('material')->model('sales_material');
            $goods = $salesMaterialObj->getlist('sm_id',array('sales_material_bn' => $filter['goods_bn']));

            $goods_id[] = 0;
            if ($goods) {
                foreach ($goods as $good ) {
                    $goods_id[] = $good['sm_id'];
                }
            }

            $where[] = 'g.sm_id in('.implode(',', $goods_id).')';
        }

        $basicMaterialObj = app::get('material')->model('basic_material');
        if ($filter['product_bn']) {
            $where = array('p.material_bn="' . $filter['product_bn'] . '"');
        }

        $sql = 'SELECT count(distinct(p.bm_id)) as _c FROM sdb_material_basic_material AS p LEFT JOIN sdb_material_sales_basic_material AS sbm ON(p.bm_id=sbm.bm_id) LEFT JOIN sdb_material_sales_material AS g ON(sbm.sm_id=g.sm_id) WHERE ' . implode(' AND ', $where);

        $count = $basicMaterialObj->db->selectrow($sql);

        $sql = 'SELECT p.bm_id,p.material_bn,p.material_name,ps.store,ps.store_freeze FROM sdb_material_basic_material AS p LEFT JOIN sdb_material_basic_material_stock AS ps ON(p.bm_id=ps.bm_id) LEFT JOIN sdb_material_sales_basic_material AS sbm ON(p.bm_id=sbm.bm_id) LEFT JOIN sdb_material_sales_material AS g ON(sbm.sm_id=g.sm_id) WHERE ' . implode(' AND ', $where) . ' GROUP BY p.bm_id LIMIT ' . $offset . ',' . $limit;

        $productList = $basicMaterialObj->db->select($sql);
        $formatFilter=kernel::single('openapi_format_abstract');
        $branchProductModel = app::get('ome')->model('branch_product');
        $data = array();
        if ($productList) {
            $productIdArr = array();
            foreach ($productList as $product) {
                $productIdArr[] = $product['bm_id'];
                $product['bn']= $formatFilter->charFilter($product['material_bn']);
                $product['name']= $formatFilter->charFilter($product['material_name']);
                $data[$product['bm_id']] = $product;
                $data[$product['bm_id']]['branchstore'] = array();
            }
            $branchProductList = $branchProductModel->getList('*',array('product_id' => $productIdArr));
            $i = '1';
            foreach ((array) $branchProductList as $bp) {
                $branch = $this->getBranch($bp['branch_id']);
                
                //根据仓库ID、基础物料ID获取该物料仓库级的预占
                $bp['store_freeze']    = $basicMStockFreezeLib->getBranchFreeze($bp['product_id'], $bp['branch_id']);
                
                $data[$bp['product_id']]['branchstore'][$i] = array(
                        'branch_bn'    => $formatFilter->charFilter($branch['branch_bn']),
                        'branch_name'  => $formatFilter->charFilter($branch['name']),
                        'store'        => $bp['store'],
                        'store_freeze' => $bp['store_freeze'],
                        'arrive_store' => $bp['arrive_store'],
                );

                $i++;
            }

            unset($branchProductList);
        }

        unset($productList);

        return array('lists' => $data, 'count' => (int) $count['_c']);
    }

    private function getBranch($branch_id)
    {

        static $branchList;

        if ($branchList[$branch_id]) return $branchList[$branch_id];

        $branchModel = app::get('ome')->model('branch');

        $branchList[$branch_id] = $branchModel->dump($branch_id,'branch_bn,name');

        return $branchList[$branch_id];
    }


    public function getDetailList($filter,$offset,$limit = 100)
    {
        $basicMStockFreezeLib  = kernel::single('material_basic_material_stock_freeze');
        $where = array();

        $basicMaterialObj = app::get('material')->model('basic_material');
        if ($filter['product_bn']) {
            $product = $basicMaterialObj->dump(array('material_bn' => $filter['product_bn']),'bm_id');
            $where['product_id'] = $product['bm_id'];
        }

        if ($filter['branch_name'] || $filter['branch_bn']) {
            $branchModel = app::get('ome')->model('branch');

            if(!empty($filter['branch_name'])){
                $branchFilter = array_unique( array('branch_bn' => $filter['branch_bn'],'name' => $filter['branch_name']) );
            }else{
                $branchFilter = array('branch_bn' => $filter['branch_bn']);
            }

            $branch = $branchModel->dump($branchFilter,'branch_id');

            $where['branch_id'] = $branch['branch_id'];
        }

        $branchProductModel = app::get('ome')->model('branch_product');

        $count = $branchProductModel->count($where);

        $branchProductList = $branchProductModel->getList('*',$where,$offset,$limit);

        $data = array();
        $formatFilter=kernel::single('openapi_format_abstract');
        if ($branchProductList) {
            $productIdArr = array();
            $i = '1';
            foreach ($branchProductList as $key => $bp) {
                $product_info = $basicMaterialObj->dump($bp['product_id'],'material_bn,material_name');
                $productIdArr[] = $bp['product_id'];

                //根据仓库ID、基础物料ID获取该物料仓库级的预占
                $bp['store_freeze']    = $basicMStockFreezeLib->getBranchFreeze($bp['product_id'], $bp['branch_id']);
                
                $data[$i]['store']            = $bp['store'];
                $data[$i]['store_freeze']     = $bp['store_freeze'];
                $data[$i]['store_in_transit'] = $bp['arrive_store'];
                $data[$i]['product_bn']   = $formatFilter->charFilter($product_info['material_bn']);
                $data[$i]['product_name'] = $formatFilter->charFilter($product_info['material_name']);
                $data[$i]['product_spec'] = '';

                $branch = $this->getBranch($bp['branch_id']);
                $data[$i]['branch_bn']   = $formatFilter->charFilter($branch['branch_bn']);
                $data[$i]['branch_name'] = $formatFilter->charFilter($branch['name']);

                $i++;
            }
        }

        return array('lists' => $data,'count' => (int) $count);
        
    }
    
    
}